''********************************
''*  16Colour Paint Application  *
''********************************
'' made by Andy Schenk  (version 0.2)
'' based on the 16colour driver by 
'' (C) 2009 Jim Bagley

CON

{Hybrid Setup
_clkmode = xtal1 + pll16x
_xinfreq = 6_000_000
modepins = %011_0000
'}
'{Proto/Demo Board Setup
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  modepins = %001_0101
'}
{Hydra Setup
_clkmode = xtal1 + pll8x
_xinfreq = 10_000_000
modepins = %011_0000
'}

 PAL=%0001
 NTSC=%0000
 INTERLACED=%0010

 x_tiles = 8  '*8fat=128
 y_tiles = 7  '*16=112
 menY    = y_tiles*16-16

 x_pixels = x_tiles*16
 y_pixels = y_tiles*16
 bsize = x_tiles*(y_tiles-1)*128

' ---- custmize ----
 MODE    =  PAL + $40   'or NTSC + $40
 SD_DO   = 8
 SD_CL   = 9
 SD_DI   = 10
 SD_CS   = 11
' ------------------
 my_hx = 22+((mode&1)<<2)
  
OBJ
  tv    : "JB_TV_AMS_02"
  kbm    : "kbm"
  sd    : "fsrwFemtoX"

VAR
  long  screen, color, oldc, cmd, zoom
  long  msx, msy, msbut, oldx, oldy, oldb
  long  curx, cury
  long  sp, sx,sy,sw,sh
  long  pcm,pct,pcb,pcl,pcr
  long  swap, typ

  long  control[2]
  long  sd_error

  byte  buff[bsize]
  byte  stack[256]

PUB Main | i,c,x,y

  sd.start(@control)
  sd_error := \sd.mount(SD_DO, SD_CL, SD_DI, SD_CS)

  kbm.start(24,25,26,27)
  swap := $10
  swapData
  screen := @data+bsize
  disp_ptr := screen
  tv.start(@tvparams)
  kbm.bound_scales(6,6,1)
  kbm.bound_limits(0,0,2,x_pixels,y_pixels,255)
  color := 1
  cmd := 1
  
  showMenu
  repeat
    mouse_evt
    if zoom==0
      if msbut==0 and msy<menY  'buttons released
        case cmd
          5: longmove(screen,@buff,bsize>>2)
'             sw := 32
'             sh := 20
             if msy < menY-sh
               obox(msx,msy,sw,sh,0)
               VSync
               obox(msx,msy,sw,sh,1)
               VSync
          10: longmove(screen,@buff,bsize>>2)

      if msbut==1 and msy<menY  'draw
        case cmd
          1..3: plot(msx,msy,color)
          8:    fill4(msx,msy,color)
          5:    sx := msx
                sy := msy
                zoomIn
                msbut := 0
          11:   repeat i from 0 to sh  'copy
                  bytemove(screen+msx>>1+(msy+i)<<6,@buff+sx>>1+(sy+i)<<6,sw>>1)
        curx := msx
        cury := msy
      if msbut==2 and msy<menY  'right button
        case cmd
          1:  plot(msx,msy,0)
          2:  lineto(msx,msy,color)
          3:  longmove(screen,@buff,bsize>>2)
              obox(curx,cury,msx-curx,msy-cury,color)
          4:  longmove(screen,@buff,bsize>>2)
              x := (msx-curx)/2
              y := (msy-cury)/2
              ellips(curx+x,cury+y,x,y,color)
          10: longmove(screen,@buff,bsize>>2)
              sx := curx
              sy := cury
              sw := msx-curx
              sh := msy-cury
              obox(curx,cury,sw,sh,0)
              VSync
              obox(curx,cury,sw,sh,1)
              VSync

    if zoom==1
      if msbut>0 and msy<menY  'draw/erase
        if msbut==1
          c := color
        else
          c := 0
        case cmd
          5:  plotb(msx>>2+sx,msy>>2+sy,c)
              y := msy & $FC
              repeat x from msx&$FC to (msx&$FC)+2
                plot(x,y+0,c)
                plot(x,y+1,c)
                plot(x,y+2,c)
       
    if msbut>0 and msy>menY  'menu
      if msx < 55
        color := msx/6 + msy&8
        if msbut==2
          editColor
      elseif msbut > 0
        oldc := cmd
        cmd := (msx-60)/10 + (msy&8)
        case cmd
          0:  longmove(@buff,screen,bsize>>2) 'cls
              bytefill(screen,0,bsize)
              if msbut==2
                repeat x from 0 to 127 step 8
                  repeat y from 0 to 91 step 8
                    plot(x,y,9)
          5:  sw := x_pixels>>2
              sh := y_pixels>>2-5
          6:  if msbut==2         'swap halfs
                tvmode ^= $40
                if swap==$10 and tvmode&$40 and zoom==0
                  longmove(@buff,screen,bsize>>2)
                  repeat i from y_pixels-17 to 0
                    longmove(screen+i<<6,@data+i<<7,16)
                  repeat until kbm.buttons==0
                  longmove(screen,@buff,bsize>>2)
                cmd := oldc
              else
                swapData
          9:  longmove(screen,@buff,bsize>>2) 'undo
              cmd := oldc
          12: savePic
          13: loadPic
          14: if msbut==3
                reboot
          
      if zoom
        if cmd<>5
          longmove(screen,@buff,bsize>>2)
          zoom := 0
      else
        if cmd>0
          longmove(@buff,screen,bsize>>2)
        else
          cmd := oldc
          
      showMenu

PRI mouse_evt
 pcm := point(oldx,oldy)
 pct := point(oldx,oldy-1)
 pcb := point(oldx,oldy+1)
 pcl := point(oldx-1,oldy)
 pcr := point(oldx+1,oldy)
 plot(oldx,oldy,0)
 plot(oldx,oldy-1,1)
 plot(oldx,oldy+1,1)
 plot(oldx-1,oldy,1)
 plot(oldx+1,oldy,1)
 repeat
   msx := kbm.bound_x
   msy := y_pixels-kbm.bound_y
   msbut := kbm.buttons
 until msbut<>oldb or msx<>oldx or msy<>oldy
 plot(oldx,oldy,pcm)
 plot(oldx,oldy-1,pct)
 plot(oldx,oldy+1,pcb)
 plot(oldx-1,oldy,pcl)
 plot(oldx+1,oldy,pcr)
 oldx := msx
 oldy := msy
 oldb := msbut

PUB showMenu | i,x,y
  bytefill(screen+menY<<6,$DD,16<<6)  'clear
  bytefill(screen+(menY+1)<<6,0,15<<6)
  repeat x from 0 to 7*6 step 6    'color boxes
    repeat y from 1 to 6
      repeat i from 1 to 5
        plot(x+i,y+menY,x/6)
    repeat y from 1 to 6
      repeat i from 1 to 5
        plot(x+i,y+menY+8,x/6+8)
  obox((color&7)*6,color&8+menY,6,7,1) 'selected

  print(string(96,97),60,menY)     'menu
  print(string("bc"),70,menY)
  print(string("de"),80,menY)
  print(string("fg"),90,menY)
  print(string("hi"),100,menY)
  print(string("jk"),110,menY)
  print(string("lm"),120,menY)

  print(string("no"),60,menY+8)
  print(string("pq"),70,menY+8)
  print(string("rs"),80,menY+8)
  print(string("tu"),90,menY+8)
  print(string("vw"),100,menY+8)
  print(string("xy"),110,menY+8)
  print(string("z{"),120,menY+8)
  obox((cmd&7)*10+59,cmd&8+menY,7,7,$D) 'selected

PRI swapData
  if zoom
    longmove(screen,@buff,bsize>>2)
  longmove(@buff,@data,bsize>>2)
  longmove(@data,@data+bsize,bsize>>2)
  longmove(@data+bsize,@buff,bsize>>2)
  swap ^= $14
  font3x7[233] := swap
  
PUB at(x,y)
  curx := x
  cury := y

PUB plot(x,y,c)
  if(x<0 or x=>x_pixels or y<0 or y=>y_pixels)
    return
  c&=15
  if(x&1)
    byte[screen][y<<6+x>>1]:=(byte[screen][y<<6+x>>1]&$f0)+c
  else
    byte[screen][y<<6+x>>1]:=(byte[screen][y<<6+x>>1]&$0f)+(c<<4)

PUB point(x,y)
  if(x<0 or x=>x_pixels or y<0 or y=>y_pixels)
    return 0
  if x&1
    return byte[screen][y<<6+x>>1] & $0F
  else                                                                                                  
    return byte[screen][y<<6+x>>1] >> 4                                                                         

PUB lineto(x,y,c) | n,w,h
  w := x-curx
  h := y-cury
  if ||w > ||h
    repeat n from 0 to w
      plot(curx+n, cury+(h*n)/w, c)
  else
    repeat n from 0 to h
      plot(curx+(w*n)/h, cury+n, c)
  curx := x
  cury := y

PUB obox(x,y,w,h,c)
  at(x,y)
  lineto(x+w,y,c)
  lineto(x+w,y+h,c)
  lineto(x,y+h,c)
  lineto(x,y,c)

PUB box(x,y,w,h,c) | i
  repeat
    repeat i from 0 to w
      plot(x+i,y+h,c)
    h--
  until h<0

PUB fill4(x,y,c) | oc
  oc := point(x,y)
  push(x,y)
  repeat while sp>0
    y := stack[--sp]
    x := stack[--sp]
    if point(x,y) == oc and x=>0 and x<x_pixels and y=>0 and y<menY and oc<>c
      plot(x,y,c)
      push(x,y+1)
      push(x,y-1)
      push(x+1,y)
      push(x-1,y)

PRI push(a,b)
  if sp < 254
    stack[sp++] := a
    stack[sp++] := b

PUB ellips(x,y,rx,ry,c)  | d,si,co
  repeat d from 0 to 360 step 2
    si := sin(d,ry)
    co := sin(d+90,rx)
    plot(x+co,y+si,c)
    
PRI sin(degree,radius) | a,q
  a := degree * 91 / 4
  q := a & $1000
  if a & $800
    a := -a
  a := word[($E000>>1|a)<<1]
  if q
    a := -a
  return (a*radius)~>16
    
PUB print(s,x,y)        's=string
  repeat while byte[s][0]
    prtchar(byte[s][0],x,y)
    if byte[s][0] < 96
      x++
    s++
    x+=3

PUB prtchar(ch,x,y)  | f,b,c
  f := (ch-32)*3
  repeat b from 1 to 7
    plot(x,y+b,font3x7[f]>>b&1)
    plot(x+1,y+b,font3x7[f+1]>>b&1)
    plot(x+2,y+b,font3x7[f+2]>>b&1)
    
PUB VSync
  repeat until VSyncFlag<>1
  repeat until VSyncFlag==1

PUB zoomIn | x,y,i
  zoom := 1
  longmove(screen,@buff,bsize>>2)
  repeat x from sw to 0
    repeat y from sh to 0
      repeat i from 2 to 0
        plot(x<<2+0,y<<2+i,pointb(sx+x,sy+y))
        plot(x<<2+1,y<<2+i,pointb(sx+x,sy+y))
        plot(x<<2+2,y<<2+i,pointb(sx+x,sy+y))
        plot(x<<2+3,y<<2+i,0)
      repeat i from 0 to 3
        plot(x<<2+i,y<<2+3,0)

PUB plotb(x,y,c)
  if(x<0 or x=>x_pixels or y<0 or y=>y_pixels)
    return
  c&=15
  if(x&1)
    buff[y<<6+x>>1]:=(buff[y<<6+x>>1]&$f0)+c
  else
    buff[y<<6+x>>1]:=(buff[y<<6+x>>1]&$0f)+(c<<4)

PUB pointb(x,y)
  if(x<0 or x=>x_pixels or y<0 or y=>y_pixels)
    return 0
  if x&1
    return buff[y<<6+x>>1] & $0F
  else                                                                                                  
    return buff[y<<6+x>>1] >> 4                                                                         

PUB editColor  | i,c,x,y
  if zoom==0
    longmove(@buff,screen,bsize>>2)
  msbut := 1
  repeat
    if msbut==1
      bytefill(screen,0,bsize)  'cls
      repeat x from 0 to 15    'show grid
        repeat y from 0 to 7
          if y==7 and x>5
            quit
          obox(x*8,y*8,6,6,1)
          c := color_nr(x,y)
          repeat i from 0 to 15  'color used?
            if palette[i] == c
              if i==color        'then colored box
                box(x*8,y*8,6,6,color)
              else
                box(x*8+1,y*8+1,4,4,i)
      hexb(palette[color],0,72)
    mouse_evt
    if msbut==1 and msy<80
      palette[color] := color_nr(msx>>3,msy>>3 <#7)
  until msy>menY
  longmove(screen,@buff,bsize>>2)

PRI color_nr(x,y) : c
  c := lookupz(y : 8, 10,11,12,13,14,15, 0)
  if c==0
    c := x+2
  else
    c := x<<4 + c

PRI hexb(v,x,y) | h
  prtchar("$",x,y)
  x+=4
  repeat 2
    h:= v>>4&15+"0"
    if h>"9"
      h+=7
    prtchar(h,x,y)
    x+=4
    v<<=4
  
PUB savePic | x,y,s
  if swap==$04
    swapData
  s := bsize
  if zoom==0
    longmove(@buff,screen,bsize>>2)
  else
    s := 1536
  bytefill(screen,0,bsize)
  print(string("SAVE *.BIT *.PAL: (OR ESC)"),0,0)
  y := getname
  if y==13
    if tvmode < $40
      s := bsize*2
    ifnot sd.popen(@name,"w")
      longmove(screen,@buff,bsize>>2)
      if typ
        sd.pwrite(@palette,16)
      else
        sd.pwrite(@data,s)
      sd.pclose
  longmove(screen,@buff,bsize>>2)

PUB loadPic | x,y
  if swap==$04
    swapData
  if zoom==0
    longmove(@buff,screen,bsize>>2)
  bytefill(screen,0,bsize)
  print(string("LOAD *.BIT *.PAL: (OR ESC)"),0,0)
  y := getname
  if y==13
    if sd.popen(@name,"r")
      y:=$CB
      print(string("NOT FOUND"),0,20)
      kbm.getkey
    else
      longmove(screen,@buff,bsize>>2)
      if typ
        sd.pread(@palette,16)
      else
        sd.pread(@data,sd.getFilesize)
      sd.pclose
      swap := $10
      swapData
      
  if y<>13
    longmove(screen,@buff,bsize>>2)

PRI getname : k | x
  if sd_error
    print(string("NO SD CARD"),0,10)
    repeat until kbm.buttons==2
    return $CB
  x:=strsize(@name)
  repeat
    bytefill(screen+640,0,640)
    print(@name,0,10)
'    prtchar(" ",x*4,10)
    k := kbm.getkey
    if k > 95
      k &= $DF
    case k
      $C8,8:  if x>0
                x--
              name[x]~
      $C4:    bytefill(@name,0,16)
              x~
      13,$CB: quit
      other:  name[x++] := k
  msbut~
  typ~
  if strcomp(@name+strsize(@name)-4,string(".PAL"))
    typ++
         
DAT

tvparams  long 0           'status
          long 1           'enable
          long modepins    'pins
tvmode    long mode        'mode
          long x_tiles     'hc
          long y_tiles     'vc
          long my_hx       'hx
VSyncFlag long 0
nextline  long 0                        
disp_ptr  long 0-0
bordercol long $02
          long @palette+$10

' ----- Picture -----

palette   byte $02,$07,$28,$9d,$BC,$DC,$db,$3d
          byte $8f,$5f,$3f,$5b,$d8,$04,$CD,$1D

data      file "mrheli.bit"
      
' ----- space for Menu -----
          byte 0[8*x_pixels]
              
font3x7
  byte  $00,$00,$00     '32
  byte  $00,$DE,$DE
  byte  $0E,$00,$0E
  byte  $FE,$28,$FE
  byte  $48,$D6,$24
  byte  $62,$18,$46
  byte  $6C,$92,$EC
  byte  $0E,$00,$0E     ''
  byte  $00,$7C,$82
  byte  $00,$82,$7C
  byte  $54,$38,$54
  byte  $10,$7C,$10
  byte  $00,$80,$60
  byte  $10,$10,$10
  byte  $00,$C0,$C0
  byte  $C0,$30,$0C
  byte  $7C,$82,$7C     '0
  byte  $04,$FE,$00
  byte  $E2,$92,$8C
  byte  $92,$92,$6C
  byte  $3E,$20,$F8
  byte  $9E,$92,$62
  byte  $7C,$92,$62
  byte  $02,$F2,$0E
  byte  $6C,$92,$6C
  byte  $8C,$92,$7C     '9
  byte  $00,$CC,$CC
  byte  $80,$EC,$6C     ';
  byte  $10,$28,$44
  byte  $28,$28,$28
  byte  $44,$28,$10
  byte  $02,$B2,$0C
  byte  $7C,$BA,$AA     '@
  byte  $FC,$12,$FC     'A
  byte  $FE,$92,$6C
  byte  $7C,$82,$82
  byte  $FE,$82,$7C
  byte  $FE,$92,$82
  byte  $FE,$12,$02
  byte  $7C,$82,$F2
  byte  $FE,$10,$FE
  byte  $82,$FE,$82
  byte  $60,$80,$7E
  byte  $FE,$38,$E6
  byte  $FE,$80,$80
  byte  $FE,$1C,$FE     'M
  byte  $FE,$02,$FC
  byte  $7C,$82,$7C
  byte  $FE,$12,$0C
  byte  $7C,$C2,$BC
  byte  $FE,$12,$EC
  byte  $8C,$92,$62
  byte  $02,$FE,$02
  byte  $7E,$80,$FE
  byte  $3E,$C0,$3E
  byte  $FE,$F0,$FE     'W
  byte  $EE,$10,$EE
  byte  $9E,$60,$1E
  byte  $E2,$9A,$86     'Z
  byte  $FE,$82,$82
  byte  $0C,$30,$C0
  byte  $82,$82,$FE
  byte  $0C,$02,$0C     '^
  byte  $80,$80,$80     '_

  byte  $3F,$2A,$3E,$2A,$3E,$00  'menu 96..123
  byte  $08,$04,$18,$20,$20,$10
  byte  $04,$04,$08,$08,$10,$10
  byte  $7C,$44,$44,$44,$44,$7C
  byte  $18,$24,$42,$42,$24,$18
  byte  $0C,$12,$72,$12,$0C,$00
  byte  $3E,$2A,$2A,$2A,$3E,$04
  
  byte  $30,$48,$46,$48,$30,$00
  byte  $38,$30,$28,$04,$04,$38
  byte  $54,$00,$44,$00,$54,$00
  byte  $0E,$0A,$3A,$2E,$28,$38
  byte  $E2,$A6,$AE,$A6,$E2,$00
  byte  $E8,$AC,$AE,$AC,$E8,$00
  byte  $00,$48,$30,$30,$48,$00

name  byte "NAME.BIT",0[8]  
              